extern float **Create_Points_Array();
extern void Draw2dOptkd();
extern void DrawOptkdNode2d();

#define PointSet 1L
#define QUERY 2L
#define DATASTRU 3L
#define QPOINT 4L

/******************************************************************************/

void DrawrnnEuclidean2d(p,querpoint,points,dimension,numpoints,
                      XProjDim,YProjDim,Bound)

/******************************************************************************/

/* special searching algorithm to take advantage of the fact that square roots
   do not need to be evaulated */

optkdNode *p;
float *querpoint;
float **points;
int dimension,numpoints,XProjDim,YProjDim;
float **Bound;

{
  int i,j,k;
  float d,thisdist,val,thisx;
  float **BLow,**BHigh;
  Coord parray[4][2];
  int left=0,right=0; 

  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];
  parray[1][0]=Bound[0][0];parray[1][1]=Bound[1][1];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];
  parray[3][0]=Bound[0][1];parray[3][1]=Bound[1][0];
  color(YELLOW); 
  polf2(4,parray);
  swapbuffers();

  printf("clearing\n");
  color(BLACK);
  polf2(4,parray);

  if (p->bucket) {
    color(GREEN);
  } else {
 
    color(RED);
    DrawOptkdNode2d(p,points,XProjDim,YProjDim,Bound);

  }
  bgnclosedline();
    for (j=0; j<4; j++) {
      v2f(parray[j]);
    }     
  endclosedline();

  BLow=Create_Points_Array(2,2);
  BHigh=Create_Points_Array(2,2);

  for (i=0; i<2; i++) {
    for (j=0; j<2; j++) {
      BLow[i][j]=Bound[i][j];
      BHigh[i][j]=Bound[i][j];
    }
  }

  if (p->bucket) {
    for (i=p->lopt; i <= p->hipt; i++) {
      thisdist=0.0;
      for (j=0; j<dimension; j++) {
        d=(querpoint[j]-points[perm[i]][j]);
        thisdist=thisdist+d*d;
      }        

      if (optfound[0] < numpoints) {
        PQInsert(thisdist,perm[i],nndist,optfound);
      } else {
        PQreplace(thisdist,nndist,optfound,perm[i]);
      }
    }
  } else {
    if (p->discrim==XProjDim) {
      BLow[0][1]=p->cutval;
      BHigh[0][0]=p->cutval;
    } else {
      if (p->discrim==YProjDim) {
        BLow[1][1]=p->cutval;
        BHigh[1][0]=p->cutval;
      } 
    }

    val = querpoint[p->discrim] - p->cutval;
    if (val < 0) {
      DrawrnnEuclidean2d(p->loson,querpoint,points,dimension,numpoints,XProjDim,YProjDim,BLow);
      left=1; 
      if (nndist[1] >= val*val) { 
        DrawrnnEuclidean2d(p->hison,querpoint,points,dimension,numpoints,XProjDim,YProjDim,BHigh);
        right=1;
      }
    } else {
      DrawrnnEuclidean2d(p->hison,querpoint,points,dimension,numpoints,XProjDim,YProjDim,BHigh);
      right=1;
      if (nndist[1] >= val*val) {
        DrawrnnEuclidean2d(p->loson,querpoint,points,dimension,numpoints,XProjDim,YProjDim,BLow);
        left=1;
      }
    }
  }
  free(BLow);free(BHigh);
}

/*******************************************************************************/

void DrawrnnGeneral2d(p,querpoint,points,dimension,numpoints,MinkP,
                    XProjDim,YProjDim,Bound)

/*******************************************************************************/


optkdNode *p;
float *querpoint;
float **points;
int dimension,numpoints,MinkP,XProjDim,YProjDim;
float **Bound;

{
  int i,j,k;
  float d,thisdist,val,thisx;
  Coord parray[4][2];
  float **BLow,**BHigh;


  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];
  parray[1][0]=Bound[0][0];parray[1][1]=Bound[1][1];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];
  parray[3][0]=Bound[0][1];parray[3][1]=Bound[1][0];
  color(YELLOW); 
  polf2(4,parray);
  swapbuffers();

  printf("clearing\n");
  color(BLACK);
  polf2(4,parray);

  if (p->bucket) {
    color(GREEN);
  } else {
 
    color(RED);
    DrawOptkdNode2d(p,points,XProjDim,YProjDim,Bound);
    color(BLUE);
  }
  bgnclosedline();
    for (j=0; j<4; j++) {
      v2f(parray[j]);
    }     
  endclosedline();

  BLow=Create_Points_Array(2,2);
  BHigh=Create_Points_Array(2,2);

  for (i=0; i<2; i++) {
    for (j=0; j<2; j++) {
      BLow[i][j]=Bound[i][j];
      BHigh[i][j]=Bound[i][j];
    }
  }

  if (p->bucket) {
    for (i=p->lopt; i <= p->hipt; i++) {
      thisdist=Distance(points,perm[i],querpoint,dimension,MinkP);

      if (optfound[0] < numpoints) {
        PQInsert(thisdist,perm[i],nndist,optfound);
      } else {
        PQreplace(thisdist,nndist,optfound,perm[i]);
      }
    }
  } else {
    if (p->discrim==XProjDim) {
      BLow[0][1]=p->cutval;
      BHigh[0][0]=p->cutval;
    } else {
      if (p->discrim==YProjDim) {
        BLow[1][1]=p->cutval;
        BHigh[1][0]=p->cutval;
      } 
    }
    val = p->cutval;
    thisx=querpoint[p->discrim];
    if (thisx < val) {
      DrawrnnGeneral2d(p->loson,querpoint,points,dimension,numpoints,MinkP,
                     XProjDim,YProjDim,BLow);
      if (thisx + nndist[1] > val) {
        DrawrnnGeneral2d(p->hison,querpoint,points,dimension,numpoints,MinkP,
                       XProjDim,YProjDim,BHigh);
      }
    } else {
      DrawrnnGeneral2d(p->hison,querpoint,points,dimension,numpoints,MinkP,
                     XProjDim,YProjDim,BHigh);
      if (thisx - nndist[1] < val) {
        DrawrnnGeneral2d(p->loson,querpoint,points,dimension,numpoints,MinkP, 
                       XProjDim,YProjDim,BLow);
      }
    }
  }
  free(BLow);free(BHigh);
}


/*******************************************************************************/

int *DrawkdOptNNQuery2d(points,numpoints,dimension, querpoint,numNN,Metric,root,MinkP,XProjDim,YProjDim)

/*******************************************************************************/

optkdNode *root;
float *querpoint, **points;
int dimension,numNN,MinkP,XProjDim,YProjDim;

{
  int j;
  float **Bound;

  float XMax=-99999.0, XMin=99999.0,
        YMax=-99999.0, YMin=99999.0;

  /* set up found array */
  optfound = (int *) malloc((numNN+1)*sizeof(int));
  optfound[0]=1;  /* for now */


  /* nndist is a priority queue of the distances of the nearest neighbors found */
  nndist = (float *)malloc((numNN+1)*sizeof(float));
  for (j=0; j < numNN+1; j++) {
    nndist[j] = 99999999999.0;
  }

  for (j=0; j<numpoints; j++) { 
    if (points[j][XProjDim] > XMax) {
      XMax=points[j][XProjDim];
    }
    if (points[j][XProjDim] < XMin) {
      XMin=points[j][XProjDim];
    }

    if (points[j][YProjDim] > YMax) {
      YMax=points[j][YProjDim];
    }
    if (points[j][YProjDim] < YMin) {
      YMin=points[j][YProjDim];
    }
  }

 /* Set up bounds similar to when drawing */
 Bound = Create_Points_Array(2,2);
 Bound[0][0]=XMin; Bound[0][1]=XMax;
 Bound[1][0]=YMin; Bound[1][1]=YMax;
 
  switch(Metric) {
    case EUCLIDEAN : DrawrnnEuclidean2d(root,querpoint,points,dimension,
                                      numNN,XProjDim,YProjDim,Bound);
                      break;
    case MANHATTAN : Distance=ManhattDist;
                     DrawrnnGeneral2d(root,querpoint,points,dimension,numNN,
                                    MinkP,XProjDim,YProjDim,Bound);
                      break;
    case L_INFINITY: Distance=LInfinityDist;
                      DrawrnnGeneral2d(root,querpoint,points,dimension,numNN,
                                     MinkP,XProjDim,YProjDim,Bound);
                      break;
    case L_P       : Distance=LGeneralDist;
                      DrawrnnGeneral2d(root,querpoint,points,dimension,numNN,
                                     MinkP,XProjDim,YProjDim,Bound);
                      break;
  }
  free(nndist);
  free(Bound);
  return(optfound);

}



/******************************************************************************/

void DrawrnnEuclidean3d(p,querpoint,points,dimension,numpoints,
                      XProjDim,YProjDim,ZProjDim,Bound)

/******************************************************************************/

/* special searching algorithm to take advantage of the fact that square roots
   do not need to be evaulated */

optkdNode *p;
float *querpoint;
float **points;
int dimension,numpoints,XProjDim,YProjDim,ZProjDim;
float **Bound;

{
  int i,j,k;
  float d,thisdist,val,thisx;
  float **BLow,**BHigh;
  Coord parray[4][3];
  int left=0,right=0; 

  color(YELLOW); 

  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][0];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][0];
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  polf(4,parray);
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][1];
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][1];
  polf(4,parray);

  parray[0][0]=Bound[0][1];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  parray[3][0]=Bound[0][1];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  polf(4,parray);
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  parray[1][0]=Bound[0][0];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  parray[2][0]=Bound[0][0];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  polf(4,parray);

  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][0];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][0];parray[2][2]=Bound[2][1];
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][0];parray[3][2]=Bound[2][1];
  polf(4,parray);
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][1];parray[0][2]=Bound[2][0];
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][1];parray[1][2]=Bound[2][0];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][1];
  polf(4,parray);
  color(RED);
  callobj(DATASTRU); 
  color(GREEN);
  callobj(QPOINT);
  swapbuffers();

/*  printf("clearing\n"); */
  color(BLACK);
  clear();
  callobj(PointSet);
/*  callobj(DATASTRU);   */

  BLow=Create_Points_Array(3,2);
  BHigh=Create_Points_Array(3,2);

  for (i=0; i<3; i++) {
    for (j=0; j<2; j++) {
      BLow[i][j]=Bound[i][j];
      BHigh[i][j]=Bound[i][j];
    }
  }

  if (p->bucket) {
    for (i=p->lopt; i <= p->hipt; i++) {
      thisdist=0.0;
      for (j=0; j<dimension; j++) {
        d=(querpoint[j]-points[perm[i]][j]);
        thisdist=thisdist+d*d;
      }        

      if (optfound[0] < numpoints) {
        PQInsert(thisdist,perm[i],nndist,optfound);
      } else {
        PQreplace(thisdist,nndist,optfound,perm[i]);
      }
    }
  } else {
    if (p->discrim==XProjDim) {
      BLow[0][1]=p->cutval;
      BHigh[0][0]=p->cutval; 
    } else {
      if (p->discrim==YProjDim) {
        BLow[1][1]=p->cutval;
        BHigh[1][0]=p->cutval; 
      } else {
        if (p->discrim==ZProjDim) {
          BLow[2][1]=p->cutval;
          BHigh[2][0]=p->cutval;
        }
      }
    }

    val = querpoint[p->discrim] - p->cutval;
    if (val < 0) {
      DrawrnnEuclidean3d(p->loson,querpoint,points,dimension,numpoints,XProjDim,YProjDim,ZProjDim,BLow); 
      left=1; 
      if (nndist[1] >= val*val) { 
        DrawrnnEuclidean3d(p->hison,querpoint,points,dimension,numpoints,XProjDim,YProjDim,ZProjDim,BHigh);
        right=1;
      }
    } else {
      DrawrnnEuclidean3d(p->hison,querpoint,points,dimension,numpoints,XProjDim,YProjDim,ZProjDim,BHigh);
      if (nndist[1] >= val*val) {
        DrawrnnEuclidean3d(p->loson,querpoint,points,dimension,numpoints,XProjDim,YProjDim,ZProjDim,BLow);
        left=1;
      }
    }
  }
  free(BLow);free(BHigh); 
}

/*******************************************************************************/

void DrawrnnGeneral3d(p,querpoint,points,dimension,numpoints,MinkP,
                    XProjDim,YProjDim,Bound)

/*******************************************************************************/


optkdNode *p;
float *querpoint;
float **points;
int dimension,numpoints,MinkP,XProjDim,YProjDim;
float **Bound;

{
  int i,j,k;
  float d,thisdist,val,thisx;
  Coord parray[4][2];
  float **BLow,**BHigh;


  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];
  parray[1][0]=Bound[0][0];parray[1][1]=Bound[1][1];
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];
  parray[3][0]=Bound[0][1];parray[3][1]=Bound[1][0];
  color(YELLOW); 
  polf2(4,parray);
  swapbuffers();

  printf("clearing\n");
  color(BLACK);
  polf2(4,parray);

  if (p->bucket) {
    color(GREEN);
  } else {
 
    color(RED);
    DrawOptkdNode2d(p,points,XProjDim,YProjDim,Bound);
  }
  bgnclosedline();
    for (j=0; j<4; j++) {
      v2f(parray[j]);
    }     
  endclosedline();

  BLow=Create_Points_Array(2,2);
  BHigh=Create_Points_Array(2,2);

  for (i=0; i<2; i++) {
    for (j=0; j<2; j++) {
      BLow[i][j]=Bound[i][j];
      BHigh[i][j]=Bound[i][j];
    }
  }

  if (p->bucket) {
    for (i=p->lopt; i <= p->hipt; i++) {
      thisdist=Distance(points,perm[i],querpoint,dimension,MinkP);

      if (optfound[0] < numpoints) {
        PQInsert(thisdist,perm[i],nndist,optfound);
      } else {
        PQreplace(thisdist,nndist,optfound,perm[i]);
      }
    }
  } else {
    if (p->discrim==XProjDim) {
      BLow[0][1]=p->cutval;
      BHigh[0][0]=p->cutval;
    } else {
      if (p->discrim==YProjDim) {
        BLow[1][1]=p->cutval;
        BHigh[1][0]=p->cutval;
      } 
    }
    val = p->cutval;
    thisx=querpoint[p->discrim];
    if (thisx < val) {
      DrawrnnGeneral2d(p->loson,querpoint,points,dimension,numpoints,MinkP,
                     XProjDim,YProjDim,BLow);
      if (thisx + nndist[1] > val) {
        DrawrnnGeneral2d(p->hison,querpoint,points,dimension,numpoints,MinkP,
                       XProjDim,YProjDim,BHigh);
      }
    } else {
      DrawrnnGeneral2d(p->hison,querpoint,points,dimension,numpoints,MinkP,
                     XProjDim,YProjDim,BHigh);
      if (thisx - nndist[1] < val) {
        DrawrnnGeneral2d(p->loson,querpoint,points,dimension,numpoints,MinkP, 
                       XProjDim,YProjDim,BLow);
      }
    }
  }
  free(BLow);free(BHigh);
}


/*******************************************************************************/

int *DrawkdOptNNQuery3d(points,numpoints,dimension, querpoint,numNN,Metric,root,MinkP,XProjDim,YProjDim,ZProjDim)

/*******************************************************************************/

optkdNode *root;
float *querpoint, **points;
int dimension,numNN,MinkP,XProjDim,YProjDim,ZProjDim;

{
  int j;
  float **Bound;

  float XMax=-99999.0, XMin=99999.0,
        YMax=-99999.0, YMin=99999.0,
        ZMax=-99999.0, ZMin=99999.0;

  float v[3];

  /* set up found array */
  optfound = (int *) malloc((numNN+1)*sizeof(int));
  optfound[0]=1;  /* for now */


  /* nndist is a priority queue of the distances of the nearest neighbors found */
  nndist = (float *)malloc((numNN+1)*sizeof(float));
  for (j=0; j < numNN+1; j++) {
    nndist[j] = 99999999999.0;
  }

  for (j=0; j<numpoints; j++) { 
    if (points[j][XProjDim] > XMax) {
      XMax=points[j][XProjDim];
    }
    if (points[j][XProjDim] < XMin) {
      XMin=points[j][XProjDim];
    }

    if (points[j][YProjDim] > YMax) {
      YMax=points[j][YProjDim];
    }
    if (points[j][YProjDim] < YMin) {
      YMin=points[j][YProjDim];
    }

    if (points[j][ZProjDim] > ZMax) {
      ZMax=points[j][ZProjDim];
    }
    if (points[j][ZProjDim] < ZMin) {
      ZMin=points[j][ZProjDim];
    }
  }

  /* Set up bounds similar to when drawing */
  Bound = Create_Points_Array(3,2);
  Bound[0][0]=XMin; Bound[0][1]=XMax;
  Bound[1][0]=YMin; Bound[1][1]=YMax;
  Bound[2][0]=ZMin; Bound[2][1]=ZMax;
  makeobj(QPOINT);
  color(GREEN);
  v[0]=querpoint[XProjDim];v[1]=querpoint[YProjDim];v[2]=querpoint[ZProjDim];
  v3f(v);
  closeobj();

  switch(Metric) {
    case EUCLIDEAN : DrawrnnEuclidean3d(root,querpoint,points,dimension,
                                      numNN,XProjDim,YProjDim,ZProjDim,Bound);
                      break;
    case MANHATTAN : Distance=ManhattDist;
                     DrawrnnGeneral3d(root,querpoint,points,dimension,numNN,
                                    MinkP,XProjDim,YProjDim,ZProjDim,Bound);
                      break;
    case L_INFINITY: Distance=LInfinityDist;
                      DrawrnnGeneral3d(root,querpoint,points,dimension,numNN,
                                     MinkP,XProjDim,YProjDim,ZProjDim,Bound);
                      break;
    case L_P       : Distance=LGeneralDist;
                      DrawrnnGeneral3d(root,querpoint,points,dimension,numNN,
                                     MinkP,XProjDim,YProjDim,ZProjDim,Bound);
                      break;
  }
  free(nndist);
  free(Bound);
  return(optfound);

}

