#include <stdio.h>

#ifdef SGI
#include "gl.h"
#include "device.h"
#else
#include "vogl.h"
#include "vodevice.h"
#endif

#ifndef TC
#include <math.h>
#else
extern double sin(), cos();
#endif

#define PointSet 1L
#define QUERY 2L
#define DATASTRU 3L

#include "naivekd.h"
#include "optkd.h"
#include "sproullkd.h"
#include "vptree.h"

extern int   dimension,numpoints;
extern float **Create_Points_Array();

void line();
void line3d();

#include "drawsproull.c"
#include "drawvp.c"
#include "graphs.c"

float pradius;


/****************************************************************************/

void range(xmin,ymin,xmax,ymax)

/****************************************************************************/

float xmin,ymin,xmax,ymax;

{
  ortho2(xmin,xmax,ymin,ymax);
}

/****************************************************************************/

void line(x1,y1,x2,y2)

/****************************************************************************/

float x1,y1,x2,y2;

{
  float v[2];
  
  color(YELLOW);
  bgnline(); 
    v[0]=x1;
    v[1]=y1;
    v2f(v);
    v[0]=x2;
    v[1]=y2;
    v2f(v);
  endline();

}

/****************************************************************************/

void line3d(x1,y1,z1,x2,y2,z2)

/****************************************************************************/

float x1,y1,x2,y2,z1,z2;

{
  float v[3];
  
  color(YELLOW);
  bgnline(); 
    v[0]=x1;
    v[1]=y1;
    v[2]=z1;
    v3f(v);
    v[0]=x2;
    v[1]=y2;
    v[2]=z2;
    v3f(v);
  endline();
/*  swapbuffers();   */
}

/****************************************************************************/

void circle(x,y,rad)

/****************************************************************************/

float x,y,rad;

{
  color(BLUE);
  circ(x,y,rad);
}

/****************************************************************************/

void OpenGLWindow()

/****************************************************************************/

{
  prefsize(850,850);
  winopen("Tonto");
  color(BLACK);
  clear();
  doublebuffer();
  gconfig();

}

/****************************************************************************/

void ClearGLDisplay()

/****************************************************************************/

{

  makeobj(PointSet);
  closeobj();

  makeobj(QUERY);
  closeobj();

  makeobj(DATASTRU);
  closeobj();

  color(BLACK);
  clear();
  swapbuffers();
}


/****************************************************************************/

void UpdateGLDisplay()

/****************************************************************************/

{
swapbuffers();
}

/****************************************************************************/

void DisplayPoints2d(Points,numpoints,XProjDim,YProjDim,Color)

/****************************************************************************/

float **Points;
int numpoints,XProjDim,YProjDim,Color;

 {
  float XMax = -999999.0,  XMin =  99999.0,
        YMax = -999999.0,  YMin =  99999.0;
  int k;
  float v[2];
  float pxmin,pxmax,pymin,pymax,dx,dy,d;

  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }
  }  
  dy=YMax-YMin;
  dx=XMax-XMin;
  d= (dx > dy ? dx : dy)*1.1;
  pxmin=XMin-(d-dx)/2.0;
  pxmax=XMax+(d-dx)/2.0;
  pymin=YMin-(d-dy)/2.0;
  pymax=YMax+(d-dy)/2.0;

  ortho2(pxmin,pxmax,pymin,pymax);
  pradius=fabs(XMax-XMin)/450.0;

  ClearGLDisplay();  
  color(Color);

  v[0] = v[1] = 0.0;
  v2f(v);
  for (k=0; k<numpoints;k++) {
    circf(Points[k][XProjDim],Points[k][YProjDim],pradius);
  }
  swapbuffers();
}


/****************************************************************************/

void DisplayProjectedPoints2d(Points,numpoints,dimension,Color)

/****************************************************************************/

float **Points;
int numpoints,dimension,Color;

{
  float XMax = -999999.0,  XMin =  99999.0;
  float v[2];
  float pxmin,pxmax,pymin,pymax,dx,dy,d;
  int XProjDim,YProjDim,k;

  for (XProjDim=0; XProjDim < dimension; XProjDim++) {
    for (k=0; k < numpoints; k++) {
      if (Points[k][XProjDim] > XMax) {
        XMax = Points[k][XProjDim];
      }
      if (Points[k][XProjDim] < XMin) {
        XMin = Points[k][XProjDim];
      }
    }
  }  
  dx=XMax-XMin;
  d= (dx)*1.1;
  pxmin=XMin-(d-dx)/2.0;
  pxmax=XMax+(d-dx)/2.0;
 
  d=pxmax-pxmin;
  ortho2(pxmin,pxmin+(dimension)*d,pxmin,pxmin+(dimension)*d);

  ClearGLDisplay();  
  color(Color);

  v[0] = v[1] = 0.0;
  v2f(v);

 color(YELLOW);
 for (k=0; k < dimension; k++) {
   bgnline();
     v[0]=pxmin+d*k;
     v[1]=pxmin;
     v2f(v);
     v[1]=pxmax+(dimension+1)*d;
     v2f(v);
   endline();
   bgnline();
     v[1]=pxmin+d*k;
     v[0]=pxmin;
     v2f(v);
     v[0]=pxmax+(dimension+1)*d;
     v2f(v);
   endline();
 }

  color(GREEN);
  for (XProjDim=0; XProjDim < dimension; XProjDim++) {
    for (YProjDim=0; YProjDim < dimension; YProjDim++) {
      for (k=0; k<numpoints;k++) {
        bgnline(); 
        v[0]=Points[k][XProjDim] + (float)XProjDim*d;
        v[1]=Points[k][YProjDim] + (float)(dimension-YProjDim-1)*d;
        v2f(v);
        v2f(v);
        endline();
      }
    }
  }
  swapbuffers();
}


/****************************************************************************/

void DisplayPoints3d(Points,numpoints,XProjDim,YProjDim,ZProjDim,Color)

/****************************************************************************/

float **Points;
int numpoints,XProjDim,YProjDim,ZProjDim,Color;

{
  float XMax = -999999.0,  XMin =  99999.0,
        YMax = -999999.0,  YMin =  99999.0,
        ZMax = -999999.0,  ZMin =  99999.0;
  float maxspread;
  int k;
  float v[3];

  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }

    if (Points[k][ZProjDim] > ZMax) {
      ZMax = Points[k][ZProjDim];
    }
    if (Points[k][ZProjDim] < ZMin) {
      ZMin = Points[k][ZProjDim];
    }
  }  


/* window(XMin-0.001,XMax+0.001,YMin-0.001,YMax+0.001,ZMin-0.001,ZMax+0.001);*/ 
  maxspread = XMax - XMin;
  if (maxspread < YMax - YMin) {
    maxspread = YMax - YMin;
  }
  if (maxspread < ZMax - ZMin) {
    maxspread = ZMax - ZMin;
  }


  perspective(300,1.0,-0.0001+ZMin-(ZMax-ZMin)/2,0.0001+ZMax+(ZMax-ZMin)/2); 
  lookat(0.0,0.0,-2.75*maxspread,0.0,0.0,-0.0,0);

  ClearGLDisplay();  

  
  makeobj(PointSet);  
  color(BLUE);
  bgnline();
    v[0]=XMin;
    v[1]=0.0;
    v[2]=0.0;
    v3f(v);
    v[0]=XMax;
    v[1]=0.0;
    v[2]=0.0;
    v3f(v);
  endline();

  bgnline();
    v[0]=0.0;
    v[1]=YMin;
    v[2]=0.0;
    v3f(v);
    v[0]=0.0;
    v[1]=YMax;
    v[2]=0.0;
    v3f(v);
  endline();

  bgnline();
    v[0]=0.0;
    v[1]=0.0;
    v[2]=ZMin;
    v3f(v);
    v[0]=0.0;
    v[1]=0.0;
    v[2]=ZMax;
    v3f(v);
  endline();


  color(Color);

  for (k=0; k<numpoints;k++) {

    bgnline(); 
      v[0]=Points[k][XProjDim];
      v[1]=Points[k][YProjDim];
      v[2]=Points[k][ZProjDim];
      v3f(v);
      v3f(v);
    endline();
  }
  closeobj();
  callobj(PointSet);
  swapbuffers();
}


/****************************************************************************/

void DisplayQueryPoints(Points,QuerPoints,XProjDim,YProjDim,Color)

/****************************************************************************
 *                                                                          *
 * Points is the set of points.  QuerPoints is an array of                  *
 * indices to the array Points which refer to points contained in the query.*
 * The first element of QuerPoints is the number of points found in the     *
 * query.                                                                   *
 *                                                                          *
 ****************************************************************************/

float **Points;
int *QuerPoints, XProjDim, YProjDim, Color;

{
  int k,Count;
  float v[2];

  Count = QuerPoints[0];  /* number of found points is the first element */ 

  color(Color);

  for (k=1; k<=Count; k++) {
      circf(Points[QuerPoints[k]][XProjDim],Points[QuerPoints[k]][YProjDim],
            pradius);
      v2f(v);
      v2f(v); 
    endline();
  }
}

/***************************************************************************/

void DisplayRectQuery2d(Points,QuerPoints,QuerRect,XProjDim,YProjDim,Color)

/***************************************************************************/

float **Points,**QuerRect;
int *QuerPoints, XProjDim,YProjDim,Color;

{
  int k;
  float v[2];
  color(Color);

  bgnclosedline(); 
    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][0];
    v2f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][0];
    v2f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][1];
    v2f(v);

    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][1];
    v2f(v);
  endclosedline();

  DisplayQueryPoints(Points,QuerPoints,XProjDim,YProjDim,Color);
  callobj(PointSet);
  swapbuffers();

}


/***************************************************************************/

void DisplayNNQuery2d(Points,QuerPoints,point,XProjDim,YProjDim,Color)

/***************************************************************************/

float **Points,*point;
int *QuerPoints, XProjDim,YProjDim,Color;

{
  int k;
  float v[2];
  color(GREEN);

  /* display query point */
  bgnline();
    v[0]=point[XProjDim];
    v[1]=point[YProjDim];
    v2f(v);
    v2f(v);
  endline();

  DisplayQueryPoints(Points,QuerPoints,XProjDim,YProjDim,Color);
  callobj(PointSet);
  swapbuffers();
}



/****************************************************************************/

void DisplayQueryPoints3d(Points,QuerPoints,XProjDim,YProjDim,ZProjDim,Color)

/****************************************************************************
 *                                                                          *
 * Points is the set of points.  QuerPoints is an array of                  *
 * indices to the array Points which refer to points contained in the query.*
 * The first element of QuerPoints is the number of points found in the     *
 * query.                                                                   *
 *                                                                          *
 ****************************************************************************/

float **Points;
int *QuerPoints, XProjDim, YProjDim, ZProjDim, Color;

{
  int k,Count;
  float v[3];

  Count = QuerPoints[0];  /* number of found points is the first element */ 

  color(Color);

  for (k=1; k<=Count; k++) {
    bgnline();
      v[0]=Points[QuerPoints[k]][XProjDim];
      v[1]=Points[QuerPoints[k]][YProjDim];
      v[2]=Points[QuerPoints[k]][ZProjDim];
      v3f(v);
      v3f(v); 
    endline();
  }
}


/***************************************************************************/

void DisplayRectQuery3d(Points,QuerPoints,QuerRect,
                        XProjDim,YProjDim,ZProjDim,Color)

/***************************************************************************/

float **Points,**QuerRect;
int *QuerPoints, XProjDim,YProjDim,ZProjDim,Color;

{
  int k;
  float v[3];


  makeobj(QUERY);
  color(Color);
  bgnclosedline(); 
    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);
  endclosedline();

  bgnclosedline(); 
    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);

    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);
  endclosedline();

  bgnline();
    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);
  endline();

  bgnline();
    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][0];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);
  endline();

  bgnline();
    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][1];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);
  endline();

  bgnline();
    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][0];
    v3f(v);

    v[0]=QuerRect[XProjDim][1];
    v[1]=QuerRect[YProjDim][0];
    v[2]=QuerRect[ZProjDim][1];
    v3f(v);
  endline();


  DisplayQueryPoints3d(Points,QuerPoints,XProjDim,YProjDim,ZProjDim,Color);
  closeobj();
  callobj(PointSet);
  callobj(QUERY);
  swapbuffers();
}

/***************************************************************************/

void DisplayNNQuery3d(Points,QuerPoints,point,
                        XProjDim,YProjDim,ZProjDim,Color)

/***************************************************************************/

float **Points,*point;
int *QuerPoints, XProjDim,YProjDim,ZProjDim,Color;

{
  float v[3];

  makeobj(QUERY);
  color(GREEN);

  /* display query point */
  bgnline();
    v[0]=point[XProjDim];
    v[1]=point[YProjDim];
    v[2]=point[ZProjDim]; 
    v3f(v);
    v3f(v);
  endline();

  DisplayQueryPoints3d(Points,QuerPoints,XProjDim,YProjDim,ZProjDim,Color);
  closeobj();
  callobj(PointSet);
  callobj(QUERY);
  swapbuffers();
}



/**************************************************************************/

void DrawkdNode2d(P,Points,XProjDim,YProjDim,Bound)

/**************************************************************************/

TreePtr P;
float **Points,**Bound;
int XProjDim,YProjDim;


{
float **BLow, **BHigh, v[2];
int k;

  BLow  = Create_Points_Array(2,2);
  BHigh = Create_Points_Array(2,2);


  for (k=0; k < 2; k++) {
    BLow[k][0]  = Bound[k][0]; BLow[k][1]  = Bound[k][1];
    BHigh[k][0] = Bound[k][0]; BHigh[k][1] = Bound[k][1];
  }

  if (P->Discrim == XProjDim) {
    bgnline(); 
      v[0]=Points[P->Index][XProjDim];
      v[1]=Bound[1][0];
      v2f(v);
      v[0]=Points[P->Index][XProjDim];
      v[1]=Bound[1][1];
      v2f(v);
    endline();

    BLow[XProjDim][1] = Points[P->Index][XProjDim];
    BHigh[XProjDim][0] = Points[P->Index][XProjDim];
  }
  else if (P->Discrim == YProjDim) {
    bgnline(); 
      v[0]=Bound[0][0];
      v[1]=Points[P->Index][YProjDim];
      v2f(v);
      v[0]=Bound[0][1];
      v[1]=Points[P->Index][YProjDim];
      v2f(v);
    endline();

    BLow[1][1] = Points[P->Index][YProjDim];
    BHigh[1][0] = Points[P->Index][YProjDim];
  }

  if (P->Left != NULL) {
    DrawkdNode2d(P->Left,Points,XProjDim,YProjDim,BLow);
  }    
  free(BLow);

  if (P-> Right != NULL) {
    DrawkdNode2d(P->Right,Points,XProjDim,YProjDim,BHigh);
  }
  free(BHigh);
}  


/**************************************************************************/

void Draw2dNaivekd(Root,Points,XProjDim,YProjDim)

/**************************************************************************/

TreePtr Root;
float **Points;
int XProjDim,YProjDim;

{
float **MaxMin;

float XMax = -999999.0,  XMin =  99999.0,
      YMax = -999999.0,  YMin =  99999.0;
int k;

  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }
  }  

  MaxMin = Create_Points_Array(2,2);
  MaxMin[0][0] = XMin; MaxMin[0][1]=XMax;
  MaxMin[1][0] = YMin; MaxMin[1][1]=YMax;
 
  color(RED);
  DrawkdNode2d(Root,Points,XProjDim,YProjDim,MaxMin);
  swapbuffers();
  free(MaxMin);
}


/**************************************************************************/

void DrawkdNode3d(P,Points,XProjDim,YProjDim,ZProjDim,Bound)

/**************************************************************************/

TreePtr P;
float **Points,**Bound;
int XProjDim,YProjDim,ZProjDim;


{
float **BLow, **BHigh, v[3];
int k;

  BLow  = Create_Points_Array(3,2);
  BHigh = Create_Points_Array(3,2);


  for (k=0; k < 3; k++) {
    BLow[k][0]  = Bound[k][0]; BLow[k][1]  = Bound[k][1];
    BHigh[k][0] = Bound[k][0]; BHigh[k][1] = Bound[k][1];
  }

  if (P->Discrim == XProjDim) {

    bgnclosedline(); 
      v[0]=Points[P->Index][XProjDim];
      v[1]=Bound[1][0];
      v[2]=Bound[2][0];
      v3f(v);
      v[2]=Bound[2][1];
      v3f(v);
      v[1]=Bound[1][1];
      v3f(v);
      v[1]=Bound[1][0];
      v3f(v);
    endclosedline();

    BLow[0][1] = Points[P->Index][XProjDim];
    BHigh[0][0] = Points[P->Index][XProjDim];
  }
  if (P->Discrim == YProjDim) {
    bgnclosedline(); 
      v[0]=Bound[0][0];
      v[1]=Points[P->Index][YProjDim];
      v[2]=Bound[2][0];
      v3f(v);
      v[0]=Bound[0][1];
      v3f(v);
      v[2]=Bound[2][1];
      v3f(v);
      v[0]=Bound[0][0];
      v3f(v);
    endclosedline();

    BLow[1][1] = Points[P->Index][YProjDim];
    BHigh[1][0] = Points[P->Index][YProjDim];
  }

  if (P->Discrim == ZProjDim) {
    bgnclosedline(); 
      v[0]=Bound[0][0];
      v[1]=Bound[1][0];
      v[2]=Points[P->Index][ZProjDim];
      v3f(v);
      v[0]=Bound[0][1];
      v3f(v);
      v[1]=Bound[1][1];
      v3f(v);
      v[0]=Bound[0][0];
      v3f(v);
    endclosedline();

    BLow[2][1] = Points[P->Index][ZProjDim];
    BHigh[2][0] = Points[P->Index][ZProjDim];
  }

  if (P->Left != NULL) {
    DrawkdNode3d(P->Left,Points,XProjDim,YProjDim,ZProjDim,BLow);
  }    
  free(BLow);
  if (P-> Right != NULL) {
    DrawkdNode3d(P->Right,Points,XProjDim,YProjDim,ZProjDim,BHigh);
  }
  free(BHigh);
}  



/**************************************************************************/

void Draw3dNaivekd(Root,Points,XProjDim,YProjDim,ZProjDim)

/**************************************************************************/

TreePtr Root;
float **Points;
int XProjDim,YProjDim;

{

float **MaxMin;

float XMax = -999999.0,  XMin =  99999.0,
      YMax = -999999.0,  YMin =  99999.0,
      ZMax = -999999.0,  ZMin =  99999.0;

int k;
float v[3];

  
  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }

    if (Points[k][ZProjDim] > ZMax) {
      ZMax = Points[k][ZProjDim];
    }
    if (Points[k][ZProjDim] < ZMin) {
      ZMin = Points[k][ZProjDim];
    }
  }  

  MaxMin = Create_Points_Array(3,2);
  MaxMin[0][0] = XMin; MaxMin[0][1]=XMax;
  MaxMin[1][0] = YMin; MaxMin[1][1]=YMax;
  MaxMin[2][0] = ZMin; MaxMin[2][1]=ZMax;

  makeobj(DATASTRU); 
  color(RED);
  DrawkdNode3d(Root,Points,XProjDim,YProjDim,ZProjDim,MaxMin);
  closeobj();
  callobj(DATASTRU);
  callobj(PointSet);
  swapbuffers();
  free(MaxMin);
}



/**************************************************************************/

void DrawOptkdNode2d(P,Points,XProjDim,YProjDim,Bound)

/**************************************************************************/

optkdNode *P;
float **Points,**Bound;
int XProjDim,YProjDim;


{
float **BLow, **BHigh, v[2];
int k;

  BLow  = Create_Points_Array(2,2);
  BHigh = Create_Points_Array(2,2);


  for (k=0; k < 2; k++) {
    BLow[k][0]  = Bound[k][0]; BLow[k][1]  = Bound[k][1];
    BHigh[k][0] = Bound[k][0]; BHigh[k][1] = Bound[k][1];
  }


  if (P->discrim == XProjDim) {
    bgnline(); 
      v[0]=P->cutval;
      v[1]=Bound[1][0];
      v2f(v);
      v[1]=Bound[1][1];
      v2f(v);
    endline();

    BLow[0][1] = P->cutval;
    BHigh[0][0] = P->cutval;
  }
  else if (P->discrim == YProjDim) {
    bgnline(); 
      v[0]=Bound[0][0];
      v[1]=P->cutval;
      v2f(v);
      v[0]=Bound[0][1];
      v[1]=P->cutval;
      v2f(v);
    endline();

    BLow[1][1] = P->cutval;
    BHigh[1][0] = P->cutval;
  }

  if (!P->loson->bucket) {
    DrawOptkdNode2d(P->loson,Points,XProjDim,YProjDim,BLow);
  }    
  free(BLow);
  if (!P->hison->bucket) {
    DrawOptkdNode2d(P->hison,Points,XProjDim,YProjDim,BHigh);
  }
  free(BHigh);
}  


/**************************************************************************/

void Draw2dOptkd(Root,Points,XProjDim,YProjDim)

/**************************************************************************/

optkdNode *Root;
float **Points;
int XProjDim,YProjDim;

{
float **MaxMin;

float XMax = -999999.0,  XMin =  99999.0,
      YMax = -999999.0,  YMin =  99999.0;
int k;

  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }
  }  

  MaxMin = Create_Points_Array(2,2);
  MaxMin[0][0] = XMin; MaxMin[0][1]=XMax;
  MaxMin[1][0] = YMin; MaxMin[1][1]=YMax;
 
  color(RED);
  DrawOptkdNode2d(Root,Points,XProjDim,YProjDim,MaxMin);
  swapbuffers();
  free(MaxMin);
}


/**************************************************************************/

void DrawOptNode3d(P,Points,XProjDim,YProjDim,ZProjDim,Bound)

/**************************************************************************/

optkdNode *P;
float **Points,**Bound;
int XProjDim,YProjDim,ZProjDim;


{
float **BLow, **BHigh, v[3];
Coord parray[4][3];
int k;

  BLow  = Create_Points_Array(3,2);
  BHigh = Create_Points_Array(3,2);

  for (k=0; k < 3; k++) {
    BLow[k][0]  = Bound[k][0]; BLow[k][1]  = Bound[k][1];
    BHigh[k][0] = Bound[k][0]; BHigh[k][1] = Bound[k][1];
  }

  if (P->discrim == XProjDim) {
    BLow[0][1] = P->cutval;
    BHigh[0][0] = P->cutval;
  }
  if (P->discrim == YProjDim) {
    BLow[1][1] = P->cutval;
    BHigh[1][0] = P->cutval;
  }

  if (P->discrim == ZProjDim) {
    BLow[2][1] = P->cutval;
    BHigh[2][0] = P->cutval;
  }

  bgnclosedline();
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  v3f(parray[0]);
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][0];
  v3f(parray[1]);
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][0];
  v3f(parray[2]);
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  v3f(parray[3]);
  endclosedline();
 /* poly(4,parray); */

  bgnclosedline();
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][1];
  v3f(parray[0]);
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  v3f(parray[1]);
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  v3f(parray[2]);
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][1];
  v3f(parray[3]);
  endclosedline();
/*  poly(4,parray); */
/*
  bgnclosedline();
  parray[0][0]=Bound[0][1];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  v3f(parray[0]);
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  v3f(parray[1]);
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  v3f(parray[2]);
  parray[3][0]=Bound[0][1];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  v3f(parray[3]);
  endclosedline();
  poly(4,parray); */
/*
  bgnclosedline();
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  v3f(parray[0]);
  parray[1][0]=Bound[0][0];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][1];
  v3f(parray[1]);
  parray[2][0]=Bound[0][0];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  v3f(parray[2]);
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][0];
  v3f(parray[3]);
  endclosedline();
  poly(4,parray); */

  bgnclosedline();
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][0];parray[0][2]=Bound[2][0];
  v3f(parray[0]);
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][0];parray[1][2]=Bound[2][0];
  v3f(parray[1]);
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][0];parray[2][2]=Bound[2][1];
  v3f(parray[2]);
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][0];parray[3][2]=Bound[2][1];
  v3f(parray[3]);
  endclosedline();
/*  poly(4,parray); */

  bgnclosedline();
  parray[0][0]=Bound[0][0];parray[0][1]=Bound[1][1];parray[0][2]=Bound[2][0];
  v3f(parray[0]);
  parray[1][0]=Bound[0][1];parray[1][1]=Bound[1][1];parray[1][2]=Bound[2][0];
  v3f(parray[1]);
  parray[2][0]=Bound[0][1];parray[2][1]=Bound[1][1];parray[2][2]=Bound[2][1];
  v3f(parray[2]);
  parray[3][0]=Bound[0][0];parray[3][1]=Bound[1][1];parray[3][2]=Bound[2][1];
  v3f(parray[3]);
  endclosedline();
/*  poly(4,parray); */


  if (!P->bucket) {
    DrawOptNode3d(P->loson,Points,XProjDim,YProjDim,ZProjDim,BLow);
    DrawOptNode3d(P->hison,Points,XProjDim,YProjDim,ZProjDim,BHigh);
    free(BLow);
    free(BHigh);
  }

}  



/**************************************************************************/

void Draw3dOptkd(Root,Points,XProjDim,YProjDim,ZProjDim)

/**************************************************************************/

optkdNode *Root;
float **Points;
int XProjDim,YProjDim;

{

float **MaxMin;

float XMax = -999999.0,  XMin =  99999.0,
      YMax = -999999.0,  YMin =  99999.0,
      ZMax = -999999.0,  ZMin =  99999.0;

int k;
float v[3];

  
  for (k=0; k < numpoints; k++) {
    if (Points[k][XProjDim] > XMax) {
      XMax = Points[k][XProjDim];
    }
    if (Points[k][XProjDim] < XMin) {
      XMin = Points[k][XProjDim];
    }

    if (Points[k][YProjDim] > YMax) {
      YMax = Points[k][YProjDim];
    }
    if (Points[k][YProjDim] < YMin) {
      YMin = Points[k][YProjDim];
    }

    if (Points[k][ZProjDim] > ZMax) {
      ZMax = Points[k][ZProjDim];
    }
    if (Points[k][ZProjDim] < ZMin) {
      ZMin = Points[k][ZProjDim];
    }
  }  

  MaxMin = Create_Points_Array(3,2);
  MaxMin[0][0] = XMin; MaxMin[0][1]=XMax;
  MaxMin[1][0] = YMin; MaxMin[1][1]=YMax;
  MaxMin[2][0] = ZMin; MaxMin[2][1]=ZMax;

  makeobj(DATASTRU); 
  color(RED);
  DrawOptNode3d(Root,Points,XProjDim,YProjDim,ZProjDim,MaxMin);
  closeobj();
  callobj(DATASTRU);
  callobj(PointSet);
  swapbuffers();
  free(MaxMin);
}







/**************************************************************************/

void GLRotatePX()

/**************************************************************************/
{
color(BLACK);
clear();
rotate(50,'x');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}

/**************************************************************************/

void GLRotateMX()

/**************************************************************************/
{
color(BLACK);
clear();
rotate(-50,'x');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}

void GLRotatePY()
{
color(BLACK);
clear();
rotate(50,'y');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}

void GLRotateMY()
{
color(BLACK);
clear();
rotate(-50,'y');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}

void GLRotatePZ()
{
color(BLACK);
clear();
rotate(50,'z');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}

void GLRotateMZ()
{
color(BLACK);
clear();
rotate(-50,'z');
callobj(PointSet);
callobj(QUERY);
callobj(DATASTRU);
swapbuffers();
}


