double fabs();

/**************************************************************************/

void DrawSproullkdNode2d(P,Bound,LParents,RParents)

/**************************************************************************/

sproullkdNode *P,**LParents,**RParents;
float **Bound;

{
float v[2],minx,maxx,miny,maxy;
int j,k; 
sproullkdNode **NewLParents, **NewRParents;
float a1,b1,c1,a2,b2,c2,det,xcand,ycand,dum;

  /* compute the largest and smallest x-coordinates in the region */

  NewLParents=(sproullkdNode **)malloc(20*sizeof(sproullkdNode *));
  NewRParents=(sproullkdNode **)malloc(20*sizeof(sproullkdNode *));

  for (j=0; j< 20; j++) {
    NewLParents[j]=NULL; NewRParents[j]=NULL;
  }

  j=0;
  a2=P->plane[0];b2=P->plane[1];c2=P->cutval;
  minx=Bound[0][0]; miny=(b2==0) ? minx : ((c2-(minx*a2))/b2);
  maxx=Bound[0][1]; maxy=(b2==0) ? maxx : ((c2-(maxx*a2))/b2);

  while (LParents[j] != NULL) {
    a1=LParents[j]->plane[0];b1=LParents[j]->plane[1];c1=LParents[j]->cutval;
    det=a1*b2-b1*a2;
    if (fabs(det) > 0.00001) { /* lines are not parallel */
      xcand=((c1*b2)-(b1*c2))/det;  /* cramers rule */
      ycand=((a1*c2)-(a2*c1))/det;
    }
    if (a1*minx+b1*miny < c1 && a1*maxx+b1*maxy < c1) {
      if (a1*minx+b1*miny < a1*maxx+b1*maxy) {
        minx=xcand;miny=ycand;
      }
      else {
        maxx=xcand;maxy=ycand;
      }
      printf("this could be wrong\n");
    } /* choose point closest to line */
    else {
      if (a1*minx+b1*miny < c1) {
        minx=xcand;miny=ycand;
      }
      if (a1*maxx+b1*maxy < c1) {
        maxx=xcand;maxy=ycand;
      }    /* determine whether this is an max or min candidate */
    }
    NewLParents[j]=LParents[j];
    j++;
  }
  NewLParents[j]=P;

  k=0;
  while (RParents[k] != NULL) {
    a1=RParents[k]->plane[0];b1=RParents[k]->plane[1];c1=RParents[k]->cutval;
    det=a1*b2-b1*a2;
    if (fabs(det) > 0.00001) { /* lines are not parallel */
      xcand=((c1*b2)-(b1*c2))/det;
      ycand=((a1*c2)-(a2*c1))/det;
    }

    if (a1*minx+b1*miny > c1 && a1*maxx+b1*maxy > c1) {
      if (a1*minx+b1*miny < a1*maxx+b1*maxy) {
        minx=xcand;miny=ycand;
      }
      else {
        maxx=xcand;maxy=ycand;
      }
      printf("this could be wrong\n");
    }
    else { 
      if (a1*minx+b1*miny > c1) {
        minx=xcand;miny=ycand;
      }
      if (a1*maxx+b1*maxy > c1) {
        maxx=xcand;maxy=ycand;
      }    /* determine whether this is an max or min candidate */
    }
    NewRParents[k]=RParents[k];
    k++;
  }
  NewRParents[k]=P;

  bgnline(); 
    v[0]=minx;
    v[1]=miny;
    v2f(v);
    v[0]=maxx;
    v[1]=maxy;
    v2f(v);
  endline();
  
  if (!P->loson->bucket) {
    DrawSproullkdNode2d(P->loson,Bound,LParents,NewRParents);
  }    
  if (!P->hison->bucket) {
    DrawSproullkdNode2d(P->hison,Bound,NewLParents,RParents);
  }
  free(NewRParents);
  free(NewLParents);
  free(RParents);free(LParents);
}  

/**************************************************************************/

void Draw2dSproullkd(Root,Points)

/**************************************************************************/

sproullkdNode *Root;
float **Points;

{
float **Maminx;
sproullkdNode **LParents,**RParents;

float Maxx = -999999.0,  Minx =  99999.0,
      Maxy = -999999.0,  Miny =  99999.0;
int k;

  for (k=0; k < numpoints; k++) {
    if (Points[k][0] > Maxx) {
      Maxx = Points[k][0];
    }
    if (Points[k][0] < Minx) {
      Minx = Points[k][0];
    }

    if (Points[k][1] > Maxy) {
      Maxy = Points[k][1];
    }
    if (Points[k][0] < Miny) {
      Miny = Points[k][1];
    }
  }  

  Maminx = Create_Points_Array(2,2);
  Maminx[0][0] = Minx; Maminx[0][1]=Maxx;
  Maminx[1][0] = Miny; Maminx[1][1]=Maxy;
 
  color(RED);
  LParents = (sproullkdNode **)malloc(20*sizeof(sproullkdNode*));
  RParents = (sproullkdNode **)malloc(20*sizeof(sproullkdNode*));

  for (k=0; k<20; k++) {
   LParents[k]=NULL; RParents[k]=NULL;
  }

  DrawSproullkdNode2d(Root,Maminx,LParents,RParents);
  swapbuffers();
  free(Maminx);
  free(LParents);free(RParents);
}



