#
#include <stdio.h>
#include <math.h> 
#include "defs.h"


#include "edgelist.c"
#include "geometry.c"
#include "heap.c"
#include "memory.c"
#include "output.c"
#include "voronoi.c"

struct Site *readone();
struct Site *nextone();


void readsites();

void DoVoronoi(numpoints,points,XProjDim,YProjDim,triang)
float **points;
int numpoints,XProjDim,YProjDim,triang;

{	
int c;
struct Site *(*next)();

sorted =0; triangulate=triang; plot=1; debug =0;

freeinit(&sfl, sizeof *sites);
if(sorted)
{	scanf("%d %f %f %f %f", &nsites, &xmin, &xmax, &ymin, &ymax);
	next = readone;
}
else 
{	readsites(points,numpoints,XProjDim,YProjDim);
	next = nextone;
};

siteidx = 0;
geominit();
if(plot) plotinit();

voronoi(triangulate, next); 
free(sites);
}

/* sort sites on y, then x, coord */
int scomp(s1,s2)
struct Point *s1,*s2;
{
	if(s1 -> y < s2 -> y) return(-1);
	if(s1 -> y > s2 -> y) return(1);
	if(s1 -> x < s2 -> x) return(-1);
	if(s1 -> x > s2 -> x) return(1);
	return(0);
}

/* return a single in-storage site */
struct Site *nextone()
{
struct Site *s;
if(siteidx < nsites)
{	s = &sites[siteidx];
	siteidx += 1;
	return(s);
}
else	return( (struct Site *)NULL);
}


/***************************************************************************/

void readsites(points,numpoints,XProjDim,YProjDim)

/****************************************************************************/

float **points;
int XProjDim,YProjDim;
/* read all sites, sort, and compute xmin, xmax, ymin, ymax */
{
int i,j;

nsites=0;
sites = (struct Site *) myalloc(1000*sizeof *sites);

for (nsites=0; nsites< numpoints; ) {
        sites[nsites].coord.x = points[nsites][XProjDim];
        sites[nsites].coord.y = points[nsites][YProjDim];
	sites[nsites].sitenbr = nsites;
	sites[nsites].refcnt = 0;
	nsites += 1;
	if (nsites % 1000 == 0) 
		sites = (struct Site *) realloc(sites,(nsites+4000)*sizeof*sites);
};

qsort(sites, nsites, sizeof *sites, scomp);
xmin=sites[0].coord.x; 
xmax=sites[0].coord.x;
for(i=1; i<nsites; i+=1)
{	if(sites[i].coord.x < xmin) xmin = sites[i].coord.x;
	if(sites[i].coord.x > xmax) xmax = sites[i].coord.x;
};
ymin = sites[0].coord.y;
ymax = sites[nsites-1].coord.y;
}

/* read one site */
struct Site *readone()
{
struct Site *s;

s = (struct Site *) getfree(&sfl);
s -> refcnt = 0;
s -> sitenbr = siteidx;
siteidx += 1;
if(scanf("%f %f", &(s->coord.x), &(s->coord.y)) == EOF)
	return ((struct Site *) NULL );
return(s);
}
